import type { IPFS } from "ipfs-core";
export interface Message<T> {
    from: string;
    data: T;
}
export declare class PubSub<T = unknown> {
    ipfs: IPFS;
    namespace: string;
    constructor(ipfs: IPFS, namespace: string);
    private getTopic;
    private encode;
    private decode;
    topics(ignoreInternals?: boolean): Promise<string[]>;
    peers(topic: string): Promise<number>;
    subscribe(topic: string, listener: (msg: Message<T>) => void): Promise<void>;
    handleRequest(method: string, listener: (args: any[], reply: (data: any) => void) => Promise<any> | any): Promise<void>;
    request(method: string, args: any[], timeout?: number): Promise<any>;
    publish(topic: string, data: T): Promise<void>;
    unsubscribe(topic: string): Promise<void>;
}
